"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const style_1 = __importDefault(require("./style"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Mask_1 = __importDefault(require("../Mask"));
const { height } = react_native_1.Dimensions.get('window');
;
const Drawer = ({ ratio = 60, style = {}, cRef, title, header, button, children, duration = 600, onClose, scrollView = true, }) => {
    const $height = height * (ratio / 100);
    const moveAnim = (0, react_1.useRef)(new react_native_1.Animated.Value(height)).current;
    const [show, setShow] = (0, react_1.useState)(false);
    const useMask = (0, react_1.useRef)();
    (0, react_1.useImperativeHandle)(cRef, () => ({
        show: () => {
            setShow(true);
        },
        hide: () => {
            _onClose();
        }
    }));
    (0, react_1.useEffect)(() => {
        var _a;
        if (!show)
            return;
        (_a = useMask === null || useMask === void 0 ? void 0 : useMask.current) === null || _a === void 0 ? void 0 : _a.show();
        fadeIn();
    }, [show]);
    const _onClose = () => {
        var _a;
        (_a = useMask === null || useMask === void 0 ? void 0 : useMask.current) === null || _a === void 0 ? void 0 : _a.hide();
        fadeOut();
        setTimeout(() => {
            setShow(false);
            onClose === null || onClose === void 0 ? void 0 : onClose();
        }, duration - 1);
    };
    const fadeOut = () => {
        react_native_1.Animated.timing(moveAnim, {
            toValue: height,
            duration,
            useNativeDriver: true
        }).start();
    };
    const fadeIn = () => {
        react_native_1.Animated.timing(moveAnim, {
            toValue: 0,
            duration,
            useNativeDriver: true
        }).start();
    };
    const renderContent = () => {
        return (react_1.default.createElement(react_native_1.View, { style: style_1.default.container },
            react_1.default.createElement(react_native_1.View, { style: [
                    style_1.default.blank,
                ] }),
            react_1.default.createElement(react_native_1.Animated.View, { style: [
                    style_1.default.content,
                    { transform: [{ translateY: moveAnim }], height: $height }
                ] },
                header ? header : (react_1.default.createElement(react_native_1.View, { style: style_1.default.title },
                    react_1.default.createElement(react_native_1.View, { style: style_1.default.left }),
                    react_1.default.createElement(react_native_1.Text, { style: [
                            style_1.default.mid,
                            title ? { lineHeight: 50 } : {}
                        ] }, title),
                    react_1.default.createElement(IconButton_1.default, { styleContainer: style_1.default.right, name: 'close', size: 20, onPress: () => {
                            _onClose();
                        } }))),
                scrollView ? (react_1.default.createElement(react_native_1.ScrollView, { style: [
                        style_1.default.scroll,
                        Object.assign({}, style)
                    ] }, children)) : (react_1.default.createElement(react_native_1.View, { style: [
                        { flex: 1 },
                        Object.assign({}, style)
                    ] }, children)),
                button ? (react_1.default.createElement(react_native_1.SafeAreaView, null, button)) : null)));
    };
    const renderView = () => {
        if (!show)
            return null;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(Mask_1.default, { cRef: useMask, duration: duration }),
            renderContent()));
    };
    return renderView();
};
exports.default = Drawer;
